/*  ==============================

  -   AVR ATmega ATtiny   - www.AVR123.nm.ru

  .
http://www.roboforum.ru/viewtopic.php?f=2&t=1070&p=11560#p11560

"  "       
avr123.nm.ru/05.htm
avr123.nm.ru/05a.htm

      
CVAVR  -          .
avr123.nm.ru         avr123.nm.ru/06.htm

CVAVR  -      .

; ************************************************************


      VMLAB
(   www.amctools.com)  :
avr123.nm.ru/z2.htm
avr123.nm.ru/z3.htm
avr123.nm.ru/z9.htm

        VMLAB

; ************************************************************

  "-"   
  -   :  avr123.nm.ru/z4.htm

///////////////////////////////////////////////////////////////

//      - PROTEUS  !!!
//    - http://www.oProteus.narod.ru

///////////////////////////////////////////////////////////////

 CVAVR 1.25.9       avr123.nm.ru

 PROTEUS 7.2 sp2     http://www.roboforum.ru/viewtopic.php?f=2&t=2398

 */


#include <mega8.h>                  // ATmega8
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif



/*   http://www.radiokot.ru/forum/viewtopic.php?t=11379&start=20

    (  ),      3    25%,
   3 .       20   20%,   70 - 100%.
   20  70    .          .


avr123.nm.ru  -     31%   20 
                    .  100%  70   .

*/



#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm

// 1_wire
#asm
.equ __w1_port=0x15 ;PORTB
.equ __w1_bit=0
#endasm

#include <lcd.h>
#include <ds18b20.h>
#include <delay.h>
#include <math.h>
#include <stdio.h>

unsigned char lcd_buffer[10];

#define MAX_DEVICES 8

/*   ROM   DS1820/DS18S20 */
unsigned char rom_code[MAX_DEVICES][9];

void main(void)
{
unsigned char i,devices;
int temp1,temp2,temp3, temp_val;


PORTB=0x00;
DDRB=0xFF;

PORTD=0x00;
DDRD=0xFF;

PORTC=0x00;
DDRC=0x00;

lcd_init(16);
lcd_putsf("  FAN CONTROLL");
delay_ms(500);

lcd_clear();

/*    DS1820/DS18S20
      1-Wire */
devices=w1_search(0xf0,rom_code);



// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 4000,000 kHz
// Mode: Fast PWM top=00FFh    15625   PROTEUS
// OC1A output: Non-Inv.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0xA1;
TCCR1B=0x09;

TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;

OCR1AH=0x00;
OCR1AL=250;

OCR1BH=0x00;
OCR1BL=250;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 4000,000 kHz
// Mode: Fast PWM top=FFh            15625   PROTEUS
// OC2 output: Non-Inverted PWM
ASSR=0x00;
TCCR2=0x69;
TCNT2=0x00;
OCR2=250;


/*     */
while (1)
{
  for (i=0;i<devices;)
  {
    temp1=ds18b20_temperature(&rom_code[0][0]);

    // PWM  OC1A   (PB1)
    if(temp1>19){

    temp_val = temp1;

    if (temp_val >= 70){
                    temp_val = 70;
                      }
     //  100%  70     31%  20 
     OCR1AL = 10 + (3 * temp_val) + (temp_val/2);
    }
    else
    {
      OCR1AL=0; //  PWM  OC1A
    }

    sprintf(lcd_buffer,"t%u=%i\xdfC",i+1,temp1/1);
    lcd_gotoxy(0,0);
    lcd_puts(lcd_buffer);
    //delay_ms(8);

    temp2=ds18b20_temperature(&rom_code[1][0]);

    // PWM  OC1B  (PB2)
    if(temp2>19){

     temp_val = temp2;

     if (temp_val >= 70){
                    temp_val = 70;
                       }
    //  100%  70     31%  20 
     OCR1BL = 10 + (3 * temp_val) + (temp_val/2);
    }
    else
    {
      OCR1BL=0; //  PWM  OC1B
    }


    sprintf(lcd_buffer,"t%u=%i\xdfC",i+2,temp2/1);
    lcd_gotoxy(0,1);
    lcd_puts(lcd_buffer);
    //delay_ms(8);

    temp3=ds18b20_temperature(&rom_code[2][0]);

    // PWM  OC2  (PB3)
    if(temp3>19){

     temp_val = temp3;

     if (temp_val >= 70){
                    temp_val = 70;
                      }

    //  100%  70     31%  20 
     OCR2 = 10 + (3 * temp_val) + (temp_val/2);

                 }
    else
    {
      OCR2=0; //  PWM  OC2
    }


    sprintf(lcd_buffer,"t%u=%i\xdfC",i+3,temp3/1);
    lcd_gotoxy(9,1);
    lcd_puts(lcd_buffer);


    delay_ms(3);

  };

};
}
